<%@ Page language="c#" Inherits="HowAspNetWorks.ResponseFilter" Codebehind="ResponseFilter.aspx.cs" %>
<!doctype html public "-//w3c//dtd html 4.0 transitional//en" >
<html>
   <head>
      <title>Response Filter Demo</title>
      <link href="~/Css/Westwind.css" rel="stylesheet" type="text/css" />
   </head>
   <body>
      <form runat="server">
         <h1>Replacing ~/ in page content</h1>
         <div class="toolbarcontainer">        
            <a href="~/" class="hoverbutton"><img src="~/css/images/home.gif" /> Back to Home Page</a>
            <a href="ResponseFilter.aspx" class="hoverbutton"><img src="~/css/images/refresh.gif" />Refresh Page</a>
         </div>
         
         <div class="contentcontainer" style="margin-top: 25px;">
             <h3><asp:label id="lblText" runat="server">Without the filter this page is mangled</asp:label></h3>             
             <hr />
             <p>
             This sample page includes links to images and style sheets references that are 
             created using application relative links<b>&lt;a href=&quot;~/default.aspx"&gt;&lt;/a&gt;</b> that
             need to be transformed into full <b>&lt;a href="<%= Request.ApplicationPath %>/default.aspx"&gt;&lt;/a&gt;</b>.
             In other words the filter is supposed to automatically provide ~/ parsing of ANY links in the page
             even if they are used in plain HTML elements.
             </p>
             
             <p>
             This demonstration provides a generic ResponseFilter stream implementation that has a TransformStream
             event that you can hook to transform the actual stream without having to reimplement 
             a full stream implementation for every 
             </p>
             
             <p>
             Here's a original URL Example:
             <b><%= !chkEnableFilter.Checked ? 
                    HttpUtility.HtmlEncode("<a href=\"~/default.aspx\">Home</a>") : 
                    HttpUtility.HtmlEncode("<a href=\"" + Request.ApplicationPath + "default.aspx\">Home</a>")  %>
             
             
             </p>
                          
             <hr />
             <asp:checkbox id="chkEnableFilter" runat="server" 
                           text="Enable Url Transformation Response Filter" 
                           autopostback="True"/>   

            <div style="display: none;">
                <p>
                adskl jaslkd jalskdja dkjasldk aslkdj aldja lkdjalkdjalksdj alksdjalksdj laksdjlak dsjlkasdjlaksdjl kasdj
                asdjalksdjalkdj laksjdlaskdjalksdjlaksjdlkasjdalksdj alskdj alskdj alkdjalskdjasld
                <a href="~/default.aspx">Home</a> | <a href="~/ResponseFilter.aspx">Refresh</a>                
                </p> 

                <p>
                adskl jaslkd jalskdja dkjasldk aslkdj aldja lkdjalkdjalksdj alksdjalksdj laksdjlak dsjlkasdjlaksdjl kasdj
                asdjalksdjalkdj laksjdlaskdjalksdjlaksjdlkasjdalksdj alskdj alskdj alkdjalskdjasld
                <a href="~/default.aspx">Home</a> | <a href="~/ResponseFilter.aspx">Refresh</a>                
                </p> 

                <p>
                adskl jaslkd jalskdja dkjasldk aslkdj aldja lkdjalkdjalksdj alksdjalksdj laksdjlak dsjlkasdjlaksdjl kasdj
                asdjalksdjalkdj laksjdlaskdjalksdjlaksjdlkasjdalksdj alskdj alskdj alkdjalskdjasld
                <a href="~/default.aspx">Home</a> | <a href="~/ResponseFilter.aspx">Refresh</a>                
                </p> 

                <p>
                adskl jaslkd jalskdja dkjasldk aslkdj aldja lkdjalkdjalksdj alksdjalksdj laksdjlak dsjlkasdjlaksdjl kasdj
                asdjalksdjalkdj laksjdlaskdjalksdjlaksjdlkasjdalksdj alskdj alskdj alkdjalskdjasld
                <a href="~/default.aspx">Home</a> | <a href="~/ResponseFilter.aspx">Refresh</a>                
                </p> 

                <p>
                adskl jaslkd jalskdja dkjasldk aslkdj aldja lkdjalkdjalksdj alksdjalksdj laksdjlak dsjlkasdjlaksdjl kasdj
                asdjalksdjalkdj laksjdlaskdjalksdjlaksjdlkasjdalksdj alskdj alskdj alkdjalskdjasld
                <a href="~/default.aspx">Home</a> | <a href="~/ResponseFilter.aspx">Refresh</a>                
                </p> 

                <p>
                adskl jaslkd jalskdja dkjasldk aslkdj aldja lkdjalkdjalksdj alksdjalksdj laksdjlak dsjlkasdjlaksdjl kasdj
                asdjalksdjalkdj laksjdlaskdjalksdjlaksjdlkasjdalksdj alskdj alskdj alkdjalskdjasld
                <a href="~/default.aspx">Home</a> | <a href="~/ResponseFilter.aspx">Refresh</a>                
                </p> 

                <p>
                adskl jaslkd jalskdja dkjasldk aslkdj aldja lkdjalkdjalksdj alksdjalksdj laksdjlak dsjlkasdjlaksdjl kasdj
                asdjalksdjalkdj laksjdlaskdjalksdjlaksjdlkasjdalksdj alskdj alskdj alkdjalskdjasld
                <a href="~/default.aspx">Home</a> | <a href="~/ResponseFilter.aspx">Refresh</a>                
                </p> 

                <p>
                adskl jaslkd jalskdja dkjasldk aslkdj aldja lkdjalkdjalksdj alksdjalksdj laksdjlak dsjlkasdjlaksdjl kasdj
                asdjalksdjalkdj laksjdlaskdjalksdjlaksjdlkasjdalksdj alskdj alskdj alkdjalskdjasld
                <a href="~/default.aspx">Home</a> | <a href="~/ResponseFilter.aspx">Refresh</a>                
                </p> 
                <p>
                adskl jaslkd jalskdja dkjasldk aslkdj aldja lkdjalkdjalksdj alksdjalksdj laksdjlak dsjlkasdjlaksdjl kasdj
                asdjalksdjalkdj laksjdlaskdjalksdjlaksjdlkasjdalksdj alskdj alskdj alkdjalskdjasld
                <a href="~/default.aspx">Home</a> | <a href="~/ResponseFilter.aspx">Refresh</a>                
                </p> 

                <p>
                adskl jaslkd jalskdja dkjasldk aslkdj aldja lkdjalkdjalksdj alksdjalksdj laksdjlak dsjlkasdjlaksdjl kasdj
                asdjalksdjalkdj laksjdlaskdjalksdjlaksjdlkasjdalksdj alskdj alskdj alkdjalskdjasld
                <a href="~/default.aspx">Home</a> | <a href="~/ResponseFilter.aspx">Refresh</a>                
                </p> 

                <p>
                adskl jaslkd jalskdja dkjasldk aslkdj aldja lkdjalkdjalksdj alksdjalksdj laksdjlak dsjlkasdjlaksdjl kasdj
                asdjalksdjalkdj laksjdlaskdjalksdjlaksjdlkasjdalksdj alskdj alskdj alkdjalskdjasld
                <a href="~/default.aspx">Home</a> | <a href="~/ResponseFilter.aspx">Refresh</a>                
                </p> 

                <p>
                adskl jaslkd jalskdja dkjasldk aslkdj aldja lkdjalkdjalksdj alksdjalksdj laksdjlak dsjlkasdjlaksdjl kasdj
                asdjalksdjalkdj laksjdlaskdjalksdjlaksjdlkasjdalksdj alskdj alskdj alkdjalskdjasld
                <a href="~/default.aspx">Home</a> | <a href="~/ResponseFilter.aspx">Refresh</a>                
                </p> 
                <p>
                adskl jaslkd jalskdja dkjasldk aslkdj aldja lkdjalkdjalksdj alksdjalksdj laksdjlak dsjlkasdjlaksdjl kasdj
                asdjalksdjalkdj laksjdlaskdjalksdjlaksjdlkasjdalksdj alskdj alskdj alkdjalskdjasld
                <a href="~/default.aspx">Home</a> | <a href="~/ResponseFilter.aspx">Refresh</a>                
                </p> 

                <p>
                adskl jaslkd jalskdja dkjasldk aslkdj aldja lkdjalkdjalksdj alksdjalksdj laksdjlak dsjlkasdjlaksdjl kasdj
                asdjalksdjalkdj laksjdlaskdjalksdjlaksjdlkasjdalksdj alskdj alskdj alkdjalskdjasld
                <a href="~/default.aspx">Home</a> | <a href="~/ResponseFilter.aspx">Refresh</a>                
                </p> 

                <p>
                adskl jaslkd jalskdja dkjasldk aslkdj aldja lkdjalkdjalksdj alksdjalksdj laksdjlak dsjlkasdjlaksdjl kasdj
                asdjalksdjalkdj laksjdlaskdjalksdjlaksjdlkasjdalksdj alskdj alskdj alkdjalskdjasld
                <a href="~/default.aspx">Home</a> | <a href="~/ResponseFilter.aspx">Refresh</a>                
                </p> 

                <p>
                adskl jaslkd jalskdja dkjasldk aslkdj aldja lkdjalkdjalksdj alksdjalksdj laksdjlak dsjlkasdjlaksdjl kasdj
                asdjalksdjalkdj laksjdlaskdjalksdjlaksjdlkasjdalksdj alskdj alskdj alkdjalskdjasld
                <a href="~/default.aspx">Home</a> | <a href="~/ResponseFilter.aspx">Refresh</a>                
                </p> 
                   
            </div>
                                        
             <hr />
             <a href="~/default.aspx">Home</a>
        </div>
      </form>
   </body>
</html>
